#ifndef __TS732_Z
#define __TS732_Z

// copyright (c)2006 Technologic Systems

#include "base.h"
#include "IntArray.h"
#include "ByteArray.h"
#include "file.h"
#include "avr.h"

STRUCT(AVRrequest);
STRUCT(AVRreply);
STRUCT(AVRconfig);
STRUCT(TS732data);

struct AVRrequest {
  dword alarm;
  // filter1,2,3
  union { // from LSB
    struct {
      word DAC1en:1,
           DAC2en:1,
           rsvd0:1,
           _LEDbot:1,
           _LEDtop:1,
           EEwrite:1,
           EEread:1,
           rsvd1:9;
    } _PACK_;
    word outputs;
  } _PACK_;
  union {
    struct {
      byte DDR5:1,
           DDR6:1,
           DDR7:1,
           DDR8:1,
           DR5:1,
           DR6:1,
           DR7:1,
           DR8:1;
    } _PACK_;
    byte DIO;
  } _PACK_;
  byte EEdata;
  byte EEadrs;
  byte ADC2filter:4,
       ADC3filter:4;
  byte ADC4filter:4,
       ADC6filter:4;
  byte ADC1filter:4,
       version:4;
  byte checksum;
} _PACK_;

struct AVRreply {
  dword millitime;
  union {
    struct {
      word ADC2max;
      word ADC2min;
      word ADC2;
      word ADC3max;
      word ADC3min;
      word ADC3;
      word ADC4max;
      word ADC4min;
      word ADC4;
      word ADC6max;
      word ADC6min;
      word ADC6;
      word ADC1max;
      word ADC1min;
      word ADC1;
    } _PACK_;
    byte EEbytes[30];
  } _PACK_;
  union { // from LSB
    struct {
      word DAC1en:1,
           DAC2en:1,
           rsvd0:1,
           _LEDbot:1,
           _LEDtop:1,
           EEwrite:1,
           EEread:1,
           rsvd1:9;
    } _PACK_;
    word outputs;
  } _PACK_ ;
  // state, from LSB
  word DR5IntGen:1,
       rsvd3:1,
       rsvd4:3,
       EEready:1,
       rsvd2:10;
  union {
    struct {
      byte DDR5:1,
           DDR6:1,
           DDR7:1,
           DDR8:1,
           DR5:1,
           DR6:1,
           DR7:1,
           DR8:1;
    } _PACK_;
    byte DIO;
  } _PACK_ ;
  byte EEdata;
  byte EEadrs;
  // filter1,2,3
  byte ADC2filter:4,
       ADC3filter:4;
  byte ADC4filter:4,
       ADC6filter:4;
  byte ADC1filter:4,
       version:4;
  byte checksum;
} _PACK_;

struct AVRconfig {
  byte reserved[126];
  word timeFactor;
  word DAC1max, DAC2max;
  word ADC2tpv, ADC2off;
  word ADC3tpv, ADC3off;
  word ADC4tpv, ADC4off;
  word ADC6tpv, ADC6off;
  word ADC1tpv, ADC1off;
  byte rsvd2[104];
} _PACK_;

struct TS732data {
  AVRconfig conf;
  word *ts732;
};

void AVRreplyPacket_Process(AVRreply *pkt,AVRrequest *default1,AVRconfig *);

inline word AVRcalcTimeFactor(dword ARMseconds,dword AVRseconds);
inline dword AVRcalcARMseconds(dword AVRseconds, word timeFactor);
inline dword AVRcalcAVRseconds(dword ARMseconds, word timeFactor);
inline word AVRcalcDACmax(word highTimeOut,word measV);
inline dword AVRcalcDAChighTime(word DACmax,word targetV);
inline dword AVRcalcTPV(word adcV2,word adcV1,word V2,word V1);
inline dword AVRcalcOff(word adcV2, word adcV1,word V2,word V1);
inline float AVRcalcADCvolts(word adcV,word adcTPV,word adcOff);
#endif
