// copyright (c)2006 Technologic Systems
#ifndef __BYTE_ARRAY_FLEX_Z
#define __BYTE_ARRAY_FLEX_Z
#include <string.h>
#include "base.h"
#include "ByteArray.h"

STRUCT(ByteArrayFlex);
STRUCT(ByteArrayFlexRef);

struct ByteArrayFlex {
  int max;   // total length allocated
  int len;
  byte arr[0];
};

struct ByteArrayFlexRef {
  int max;     // total length allocated
  union {
    struct {
      int len;     // length of array in use
      byte *arr;   // pointer to start of array in use
    };
    struct ByteArrayRef ref;
  };
};

#define BAFref ByteArrayFlexRef
inline BAFref BAFR(byte *ptr,int len,int max);
inline BAFref ByteArrayFlexRef_Bound(BAFref str,int offset,int *len);
inline BAFref ByteArrayFlexRef_InsertIn(BAFref str,ByteArrayRef str2,int ofs);
inline BAFref ByteArrayFlexRef_PrependTo(BAFref str,ByteArrayRef newstr);
inline BAFref ByteArrayFlexRef_AppendTo(BAFref str,ByteArrayRef newstr);
inline BAFref ByteArrayFlexRef_DeleteFrom(BAFref str,int offset,int count);
inline BAFref ByteArrayRef_Truncate(BAFref str,int newlen);
BAFref ByteArrayFlexRef_Substring(BAFref str,int offset,int len);

#endif
