// copyright (c)2006 Technologic Systems
#ifndef __FILTER_Z
#define __FILTER_Z

#include "base.h"

STRUCT(filter);
STRUCT(filterDataSmoothAverageFloat);
STRUCT(filterDataSchmittTriggerFloat);

struct filter {
  int (*push)(filter *f,void *din);
  void *(*pull)(filter *f,void *dout);
  void *data;
  void *tmp;
};

struct filterDataSmoothAverageFloat {
  int numSamples,maxSamples;
  float *data;
};

struct filterDataSchmittTriggerFloat {
  float highWater,lowWater,lastValue;
  int passingData:1;
};

inline int filterPush(filter *f,void *din); // TRUE if data ready to be pulled
inline void *filterPull(filter *f,void *dout); // returns dout if it was filled
inline filter *filterDo(filter *filt,filter *prev);
inline filter *filterDo0(filter *filt,void *din);

void filterDataSmoothAverageFloat_Init(filter *f,int maxSamples);
void filterDataSchmittTriggerFloat_Init(filter *f,float hi,float lo);
void filterDataRateFloat_Init(filter *f,int maxSamples);


#endif
